


local function run(event)

-- local simulation= 1 						--1 for companion simulation
-- local simulation= 0 						--0 for use on transmitter

local simulation= 0 						-- DO NOT FORGET TO PUT TO ZERO if not in simulation with companion

  local settings = getGeneralSettings()

-- ################# Draw Frames ########################

  lcd.drawLine(37, -1, 37, 64, SOLID, GREY_DEFAULT)    -- Vertical line 1
  lcd.drawLine(100, -1, 100, 64, SOLID, GREY_DEFAULT)  -- Vertical line 2
  lcd.drawLine(162, -1, 162, 64, SOLID, GREY_DEFAULT)  -- Vertical line 3

  lcd.drawLine(36, 21, 162, 21, SOLID, GREY_DEFAULT)   -- Horizointal line 1
  lcd.drawLine(36, 42, 162, 42, SOLID, GREY_DEFAULT)   -- Horizontal line 2


-- The 0% value for 2S, 3S, 4S, you can change these to your own likings.
local six_low=22.2
local five_low=18.5
local four_low=14.8
local three_low=11.1 --3.7V
local two_low=7.4 

-- The 100% value for 2S, 3S, 4S, , you can change these to your own likings.
local six_high=25.2
local five_high=21.0
local four_high=16.8
local three_high=12.6
local two_high=8.4

-- ################  Battery Display ###############

local battype = 3
local battypestr="_S"

local percent=0
local batt_sum = getValue("vfas")
local mySpeed = getValue("accy") * 100.0
local myHeight = getValue("accx") * 100.0               -- GPS Height


if simulation == 1 then
  batt_sum = 16.1 										-- for simulation only
  mySpeed = 12											-- for simulation only
  myHeight = 299
end

   if batt_sum>3 then
    battype=math.ceil(batt_sum/4.25)
    if battype==6 then
	  battypestr="6S"
	  percent = (batt_sum-six_low)*(100/(six_high-six_low))
	end
	if battype==5 then
	  battypestr="5S"
	  percent = (batt_sum-five_low)*(100/(five_high-five_low))
	end
	if battype==4 then
	  battypestr="4S"
	  percent = (batt_sum-four_low)*(100/(four_high-four_low))
	end
	if battype==3 then
	  battypestr="3S"
	  percent = (batt_sum-three_low)*(100/(three_high-three_low))
	end
	if battype==2 then
	  battypestr="2S"
	  percent = (batt_sum-two_low)*(100/(two_high-two_low))
	end
   end


 
   local myPxHeight = math.floor(percent * 0.37)            	
   local myPxY = 11 + 37 - myPxHeight

   lcd.drawPixmap(3, 1, "/SCRIPTS/BMP/battery.bmp")

   if percent > 0 then
   	lcd.drawFilledRectangle(8, myPxY, 21, myPxHeight, FILL_WHITE ) 
   end

    local i = 36
    while (i > 0) do
    	lcd.drawLine(7, 11 + i, 27, 11 +i, SOLID, GREY_DEFAULT)
    	i= i-2
    end

   if (percent < 15) then
    lcd.drawNumber(4,55, batt_sum * 100  ,PREC2 + LEFT + BLINK)
   else
    lcd.drawNumber(4,55, batt_sum * 100  ,PREC2 + LEFT)
   end
    lcd.drawText(lcd.getLastPos(), 55, "v ", 0)
--  lcd.drawText(lcd.getLastPos(), 55,battypestr,0)


 
-- ################### Flightmode selection ###############################

-- Change Switches down here for you personal configuration
-- Currently configued with:
-- IOC on Swith SG
-- Failsave on Switch SF
-- Manual, Atti and GPS ons switch SB

  lcd.drawPixmap(46, 3, "/SCRIPTS/BMP/fm.bmp")                        -- Flight mode bmp
  
  
  if getValue("rssi") > 20 then                                       -- RSSI > 20 then show rest 
    if getValue("sb") > 0 then                                       -- If Failsave (Switch SF)
        lcd.drawText(66, 5, "MAN", MIDSIZE)      
    else 
        if getValue("sb") == 0 then
          lcd.drawText(66, 5, "ATTI", MIDSIZE)
        else 
          lcd.drawText(66, 5, "GPS", MIDSIZE)
        end                                               
    end
    if getValue("sc") == 0 then
      lcd.drawText(130, 24, "HOME", 0)                          -- Show Homelock
    else 
        if getValue("sc") < 0 then 
            lcd.drawText(130, 24, "LOCK", 0)  
        else 
             lcd.drawText(130, 24, "RTH ", BLINK+MIDSIZE)                     --
        end
    end                                                           
  else                                                                -- RSSI < 20
    lcd.drawText(66, 5, "FAIL", BLINK+MIDSIZE)                        -- show FAIL
  end                                                                 

-- ####################### Gimball  ##########################

  --local angle = (getValue("rs")+1024)*90/2048						  -- Gimball postion (Right slider)
  local angle = getValue("heading")
  lcd.drawNumber(77, 46, angle, LEFT+MIDSIZE)
  lcd.drawText(lcd.getLastPos(), 46, "o", SMLSIZE)

if simulation == 1 then
   --angle = 5
end 

  if angle > 75 then
  lcd.drawPixmap(46, 46, "/SCRIPTS/BMP/gb90a.bmp")
  elseif angle > 35 then
        lcd.drawPixmap(46, 46, "/SCRIPTS/BMP/gb45a.bmp")
  elseif angle > 0 then
        lcd.drawPixmap(46, 46, "/SCRIPTS/BMP/gb0a.bmp")
  else
         lcd.drawPixmap(46, 46, "/SCRIPTS/BMP/gb0a.bmp")
 end

-- ############## Speed ########################################

 --local mySpeed = getValue("gps-speed") 
   mySpeed = mySpeed * 3.6                                              -- 1ms = 3,6 kmh  
   --lcd.drawPixmap(110, 46, "/SCRIPTS/BMP/speed.bmp")   
	 lcd.drawText(110, 45, "SPD:" , SMLSIZE)
	 lcd.drawNumber(130,45, mySpeed , SMLSIZE + LEFT)
	 lcd.drawText(lcd.getLastPos(), 45, "cms" , SMLSIZE)

	 lcd.drawText(110, 53, "HGT:" , SMLSIZE)
	 lcd.drawNumber(130,53, myHeight , SMLSIZE + LEFT)
	 lcd.drawText(lcd.getLastPos(), 53, "cm" , SMLSIZE)
 

-- ############## Distance ########################################
   lcd.drawPixmap(110, 0, "/SCRIPTS/BMP/dist.bmp")
   lcd.drawNumber(130, 4, getValue("distance"), LEFT+MIDSIZE)         -- Distance in meters
   lcd.drawText(lcd.getLastPos(), 4, "m", MIDSIZE)

-- ################# GPS Quality ##################################
   local myNumSat =  getValue("temp1")                                   -- Temp1 is number of sats
   local myQualSat =  getValue("temp2")                                  -- Temp2 is quality of Satfix
   
if simulation == 1 then
 myNumSat =7                                                       	     -- for Taranis Simulations Mode
 myQualSat =3                                                            -- for Taranis Simulations Mode
end
   
   if myQualSat == 0 then
  		lcd.drawPixmap(46, 24, "/SCRIPTS/BMP/sat0.bmp")                	 -- NO Fix
   elseif myQualSat == 2 then
			lcd.drawPixmap(46, 24, "/SCRIPTS/BMP/sat1.bmp")              -- 2D Fix
   elseif myQualSat == 3 then
			lcd.drawPixmap(46, 24, "/SCRIPTS/BMP/sat2.bmp")              -- 3D Fix
   elseif myQualSat == 4 then
			lcd.drawPixmap(46, 24, "/SCRIPTS/BMP/sat3.bmp")              -- DGPS FIX
	 end				
	 if myNumSat > 4 then
	 		lcd.drawPixmap(66, 25, "/SCRIPTS/BMP/gps_0.bmp")             -- 6 or more Sats 
	 elseif myNumSat > 3 then
	 		lcd.drawPixmap(66, 25, "/SCRIPTS/BMP/gps_1.bmp")               -- 5 Sats 
	 elseif myNumSat > 2.5 then
	 		lcd.drawPixmap(66, 25, "/SCRIPTS/BMP/gps_2.bmp")               -- 4 Sats
	 elseif myNumSat > 2 then
	 	  lcd.drawPixmap(66, 25, "/SCRIPTS/BMP/gps_3.bmp")               -- 3 Sats
	 elseif myNumSat > 1.5 then
	 		lcd.drawPixmap(66, 25, "/SCRIPTS/BMP/gps_4.bmp")               -- 2 Sats
	 elseif myNumSat > 1 then
	 		lcd.drawPixmap(66, 25, "/SCRIPTS/BMP/gps_5.bmp")               -- 1 Sat
	 else
	 	lcd.drawPixmap(66, 25, "/SCRIPTS/BMP/gps_6.bmp")                 -- no Sats
	 end
   lcd.drawNumber(73, 24, myNumSat,  SMLSIZE)                            -- Show number of sats

-- ################### Home Point ######################################
-- ### When Pilots Position known set homepoint              ###########

if simulation == 1 then
      lcd.drawPixmap(110, 24, "/SCRIPTS/BMP/home.bmp")
      lcd.drawPixmap(130, 24, "/SCRIPTS/BMP/check.bmp")
else
   
   lcd.drawPixmap(110, 24, "/SCRIPTS/BMP/home.bmp")

end

-- ############### RSSI ##############################################

  if getValue("rssi") > 38 then
   percent = ((math.log(getValue("rssi")-28, 10)-1)/(math.log(72, 10)-1))*100
  else
   percent = 0
  end

  if percent > 90 then
   	lcd.drawPixmap(164, 1, "/SCRIPTS/BMP/RSSI10.bmp")
  elseif percent > 80 then
		lcd.drawPixmap(164, 1, "/SCRIPTS/BMP/RSSI09.bmp")
  elseif percent > 70 then
		lcd.drawPixmap(164, 1, "/SCRIPTS/BMP/RSSI08.bmp")
  elseif percent > 60 then
		lcd.drawPixmap(164, 1, "/SCRIPTS/BMP/RSSI07.bmp")
  elseif percent > 50 then
		lcd.drawPixmap(164, 1, "/SCRIPTS/BMP/RSSI06.bmp")
  elseif percent > 40 then
		lcd.drawPixmap(164, 1, "/SCRIPTS/BMP/RSSI05.bmp")
  elseif percent > 30 then
		lcd.drawPixmap(164, 1, "/SCRIPTS/BMP/RSSI04.bmp")
  elseif percent > 20 then
		lcd.drawPixmap(164, 1, "/SCRIPTS/BMP/RSSI03.bmp")
  elseif percent > 10 then
		lcd.drawPixmap(164, 1, "/SCRIPTS/BMP/RSSI02.bmp")
  elseif percent > 0 then
		lcd.drawPixmap(164, 1, "/SCRIPTS/BMP/RSSI01.bmp")
  else
    lcd.drawPixmap(164, 1, "/SCRIPTS/BMP/RSSI00.bmp")
  end

  lcd.drawChannel(178, 55, 200, LEFT)
  lcd.drawText(lcd.getLastPos(), 56, "dB", SMLSIZE)

end

return { run=run }